# stats.tcl
#	system statistics frame 


loadsource stats.common
set NUM 64

set ITEM(1) "Looking for data"
set ITEM(2) "empty event"
set ITEM(3) "Histogram increments"
set ITEM(4) "Buffers transmitted"
set ITEM(5) "Total data transmitted"
set ITEM(6) "Null events"
set ITEM(7) "fifo empty"

# set ITEM(9) "SAC no event"

set ITEM(11) "Event not acceptable"
set ITEM(12) "Bad data"
set ITEM(13) "Events"

set ITEM(14) "Transfer error"
set ITEM(15) "Waiting for network"
# set ITEM(16) "TDC no START item"
# set ITEM(10) "SAC EvCnt read error"
# set ITEM(17) "SAC multiple events"
# set ITEM(18) "SAC not armed"
# set ITEM(19) "SAC stopped"


set ITEM(20) "V1724 events"
set ITEM(21) "V1724 no data"
set ITEM(22) "V1724FLUSH"
set ITEM(23) "V1724 items"
set ITEM(24) "V1724 blocks"
set ITEM(25) "V1724FIFOABORT"
set ITEM(26) "V1724FIFOEMPTY"
set ITEM(27) "V1724 Bad Hdr1"
set ITEM(28) "V1724 Bad Hdr2"
set ITEM(29) "V1724 Bad Event1"

set ITEM(30) "V1724 Short Event"
set ITEM(31) "V1724 Null Event"
set ITEM(32) "V1724 Bad Sample"
set ITEM(33) "V1724 No E"
set ITEM(34) "V1724 No T"
set ITEM(35) "V1724 Bad Event2"
set ITEM(36) "V1724 BlkErr"
set ITEM(37) "V1724 BusErr"
set ITEM(38) "V1724 data"
set ITEM(39) "V1724 Long Event"
set ITEM(40) "V1724 Block Len Err"



set ITEM(41) "CAEN data items"
# set ITEM(42) "CAEN fifo waiting"
# set ITEM(43) "CAEN fifo abort"
# set ITEM(44) "CAEN Bad data"
# set ITEM(45) "CAEN fifo empty"
set ITEM(46) "CAEN events"
# set ITEM(47) "CAEN fifo flush"
set ITEM(48) "CAEN data items flushed"
# set ITEM(49) "CAEN TDC overflow"
# set ITEM(50) "CAEN TDC multiple hits"
set ITEM(51) "CAEN ADC overflow"
set ITEM(52) "CAEN ADC underflow"
set ITEM(53) "CAEN ADC Range"
# set ITEM(54) "CAEN TDC no start"
set ITEM(55) "CAEN total data count"
# set ITEM(56) "CAEN fifo waiting"
# set ITEM(57) "CAEN fifo abort"
# set ITEM(58) "CAEN fifo empty"
set ITEM(59) "CAEN Bad data"





proc click-redisplay {} {NEWclick-redisplay}
proc do_update {} {NEWupdate}
proc read-Rate {n} {NEWread-Rate $n}
proc read-Stat {n} {NEWread-Stat $n}
set NumBlocks 1



#    support for Web Service access  -  provides application specific support

proc do_GetCounters {} {
    upvar NUM NUM

#   puts "do_GetCounters:"

    do_update

    set rc ""
    for {set i 0} {$i < $NUM} {incr i} {append rc "[read-Stat $i] "}

    return $rc
}

proc do_GetRates {} {
    upvar NUM NUM

#   puts "do_GetRates:"

    set rc ""
    for {set i 0} {$i < $NUM} {incr i} {append rc "[read-Rate $i] "}

    return $rc
}


